#include <stdio.h>

    /* Laenge eines Strings bestimmen */
int my_strlen1(char s[]) {
    int i;
	/* bis zum abschliessenden Null-Byte laufen */
    for (i = 0; s[i] != '\0'; i++); /* leere Anweisung! */
    return i;
}

    /* Laenge eines Strings bestimmen */
int my_strlen2(char *s) {
    int len;
	/* bis zum abschliessenden Null-Byte laufen */
    for (len = 0; *s != '\0'; s++, len++);
    return len;
}

    /* Kopieren eines String
     * Vorauss.: genuegend Platz in t */
void my_strcpy1(char t[], char s[]) {
    int i;
    for (i = 0; (t[i] = s[i]) != '\0'; i++);
}

    /* Kopieren eines String
     * Vorauss.: genuegend Platz in t */
void my_strcpy2(char *t, char *s) {
    for (; (*t = *s) != '\0'; t++, s++);
}

    /* Kopieren eines String
     * Vorauss.: genuegend Platz in t */
void my_strcpy3(char *t, char *s) {
    while ((*t++ = *s++) != '\0');
}

    /* Kopieren eines String
     * Vorauss.: genuegend Platz in t */
void my_strcpy4(char *t, char *s) {
    while (*t++ = *s++);	/* TRUE entspricht != 0 */
}

    /* Vergleich zweier Strings
     * Ergebnis: 0 fuer s = t, > 0 fuer s > t und < 0 fuer s < t */
int my_strcmp1(char s[], char t[]) {
    int i;
    for (i = 0; s[i] == t[i] && s[i] != '\0'; i++);
    return s[i] - t[i];
}

    /* Vergleich zweier Strings
     * Ergebnis: 0 fuer s = t, > 0 fuer s > t und < 0 fuer s < t */
int my_strcmp2(char *s, char *t) {
    for (; *s == *t && *s != '\0'; s++, t++);
    return *s - *t;
}

int main() {
    char str1[] = "Hallo Welt!";
    char str2[20];

    printf("my_strlen1(str1) = %d\n", my_strlen1(str1));

    my_strcpy1(str2, str1);
    printf("my_strcpy1(str2, str1) => str2 = %s\n", str2);

    my_strcpy1(str2, "Hallo Tom!");
    printf("my_strcmp1(str1, str2) = %d\n", my_strcmp1(str1, str2));
    printf("my_strcmp1(str2, str1) = %d\n", my_strcmp1(str2, str1));
    printf("my_strcmp1(str1, str1) = %d\n", my_strcmp1(str1, str1));

    return 0;
}
